// ----------------------------------------------------------------
// The contents of this file are distributed under the CC0 license.
// See http://creativecommons.org/publicdomain/zero/1.0/
// ----------------------------------------------------------------

import java.awt.event.MouseListener;
import java.awt.event.KeyListener;
import java.awt.event.MouseEvent;
import java.awt.event.KeyEvent;
import java.util.TreeMap;
import java.util.Random;
import java.util.Comparator;

class Controller implements MouseListener, KeyListener
{
	static Random rand = new Random(1234);
	Model model;
	View view;
	double trans_dev;
	double[] in;
	boolean[] arrowKeys;

	Controller(Model m, View v, double trans_noise_dev)
	{
		model = m;
		view = v;
		trans_dev = trans_noise_dev;
		in = new double[6];
		arrowKeys = new boolean[4];
	}

	public void mousePressed(MouseEvent e)
	{
		//model.onClick(e.getX(), e.getY());
	}

	public void mouseReleased(MouseEvent e)
	{
	}

	public void mouseEntered(MouseEvent e)
	{
	}

	public void mouseExited(MouseEvent e)
	{
	}

	public void mouseClicked(MouseEvent e)
	{
	}

	void transition(int action)
	{
		in[0] = model.state[0];
		in[1] = model.state[1];
		in[2 + action] = 1.0;
		double[] pred = model.trans.forwardProp(in);
		in[2 + action] = 0.0;
		model.state[0] += pred[0] + model.rand.nextGaussian() * trans_dev;
		model.state[1] += pred[1] + model.rand.nextGaussian() * trans_dev;
	}

	public void keyPressed(KeyEvent e)
	{
		char c = e.getKeyChar();
		if(c == ' ')
		{
			System.out.println("Congratulations, you have discovered what happens when you press the space bar!");
		}

		int n = e.getKeyCode();
		if(n == KeyEvent.VK_RIGHT)
			arrowKeys[0] = true;
		if(n == KeyEvent.VK_LEFT)
			arrowKeys[1] = true;
		if(n == KeyEvent.VK_UP)
			arrowKeys[2] = true;
		if(n == KeyEvent.VK_DOWN)
			arrowKeys[3] = true;
	}

	public void keyReleased(KeyEvent e)
	{
		int n = e.getKeyCode();
		if(n == KeyEvent.VK_RIGHT)
			arrowKeys[0] = false;
		if(n == KeyEvent.VK_LEFT)
			arrowKeys[1] = false;
		if(n == KeyEvent.VK_UP)
			arrowKeys[2] = false;
		if(n == KeyEvent.VK_DOWN)
			arrowKeys[3] = false;
	}

	public void keyTyped(KeyEvent e)
	{
	}

	void update()
	{
		if(arrowKeys[0])
			transition(1);
		if(arrowKeys[1])
			transition(0);
		if(arrowKeys[2])
			transition(2);
		if(arrowKeys[3])
			transition(3);
	}
}
